//*****************************************
// 	Zv iOtBbNkbcgpj Program ATMega328
// CPU Clock:1MHz
//   iq[Yf[^@WāAUWlgɂj
//
// File Name:timer.c
//
//  ^C}[Q͂qsbƂĎgB
//  ^C}[O͂POr̃^C}[ƂĎgB
//
//  2017/05/30 New(TAB4)  Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>


#include	"timer.h"
#include	"switch.h"


unsigned char	tim_1ms;						// 10mSPʂJE^[
unsigned char	tim_10ms;						// PbPʂJE^[
unsigned char	tim_1s_escape;					// ݒ胂[h甲ׂ̂PrPʃ^C}[
unsigned char	tim_10ms_blink;					// \uNpPOrPʃ^C}[
unsigned char	tim_1sec_clk;
unsigned char	tim_1min_clk;
unsigned char	tim_1hou_clk;

// **********************************************************
// ************************ Timer 0 *************************
// **********************************************************
// 1MHz-- 1mS Interrupt
#define	COUNT_1MS		125															// 1mS at 1MHz/8 = 125kHz(8uS)
#define	D_TCCR0A	((0 << COM0A1) | (0 << COM0A0) | (1 << WGM01) | (0 << WGM00))	// A Comper Match, Dont Output Timer0 Signal
#define	D_TCCR0B	((0 << WGM02) | (0 << CS02) | (1 << CS01) | (0 << CS00))		// Timer Start (1MHz/8= 125kHz, 8uS)

//*****************************************
// Timer0 Initial
//  1mS 荞݂ɐݒ肷
//*****************************************
void	Timer0_init(void)
{
	PRR &= ~(1 << PRTIM0);			// d͍팸~߂

	TCCR0B = 0;						// Timer Stop
	TCNT0 = 0;						// Timer0 Count Set to ZERO
	TCCR0A = D_TCCR0A;				// A Comper Match, Dont Output Timer0 Signal
	OCR0A  = COUNT_1MS;				// 1mS
	TCCR0B = D_TCCR0B;				// Timer Start
	TIMSK0 |= (1 << OCIE0A);		// A Comper Match Interrupt Enable

	tim_1ms = 10;					// 10mSPʂJE^[
	tim_10ms = 0;					// PbPʂJE^[
	tim_1s_escape = 0;				// ݒ胂[h甲ׂ̂PrPʃ^C}[
	tim_10ms_blink = 0;				// \uNpPOrPʃ^C}[
	tim_1sec_clk = 0;
	tim_1min_clk = 0;
	tim_1hou_clk = 0;

	gTim_10ms_sw = 0;				// XCb`pPOrPʃ^C}[
	gTim_10ms_sw2_length = 0;		// EXCb`pԂPOrPʃ^C}[
	gTim_10ms_sw2_continue = 0;		// EXCb`pAPOrPʃ^C}[
	gTim_10ms_sw1_length = 0;		// XCb`pԂPOrPʃ^C}[
	gTim_10ms_sw1_continue = 0;		// XCb`pAPOrPʃ^C}[
	gTim_10ms_sws_length = 0;		// ʃXCb`pԂPOrPʃ^C}[
	gTim_10ms_sws_continue = 0;		// ʃXCb`pAPOrPʃ^C}[

}
//*****************************************
// Timer0 Close
//  Timer0 ̎gp߂
//*****************************************
void	Timer0_close(void)
{
	TCCR0B = 0;											// Timer Stop
	TCNT0 = 0;											// Timer0 Count Set to ZERO
	TCCR0A = 0;											// Dont Output Timer0 Signal
	TIMSK0 = 0;											// Interrupt Disable

}
//***************************
// Timer0 Comper Match A Interrupt
//
//  1mS 
//***************************
ISR	(TIMER0_COMPA_vect)	
{
	tim_1ms++;
	if(10 <= tim_1ms){					// 10mSo
		tim_1ms = 0;
		tim_10ms++;
		if(100 <= tim_10ms){					// Pbo
			tim_10ms = 0;
			tim_1sec_clk++;
			if(60 <= tim_1sec_clk){
				tim_1sec_clk = 0;
				tim_1min_clk++;
				if(60 <= tim_1min_clk){
					tim_1min_clk = 0;
					tim_1hou_clk++;
					if(100 <= tim_1hou_clk){
						tim_1hou_clk = 0;
					}
				}
			}
			if(tim_1s_escape != 0){
				tim_1s_escape--;				// ݒ胂[h甲ׂ̂PrPʃ^C}[
			}

		}

		if(tim_10ms_blink != 0){
			tim_10ms_blink--;					// \uNpPOrPʃ^C}[
		}

		if(gTim_10ms_sw != 0){				// XCb`pPOrPʃ^C}[
			gTim_10ms_sw--;					// XCb`pPOrPʃ^C}[
		}

		if(gTim_10ms_sw2_length != 0){		// EXCb`pԂPOrPʃ^C}[
			gTim_10ms_sw2_length--;
		}

		if(gTim_10ms_sw2_continue != 0){	// EXCb`pAPOrPʃ^C}[
			gTim_10ms_sw2_continue--;
		}

		if(gTim_10ms_sw1_length != 0){		// XCb`pԂPOrPʃ^C}[
			gTim_10ms_sw1_length--;
		}

		if(gTim_10ms_sw1_continue != 0){	// XCb`pAPOrPʃ^C}[
			gTim_10ms_sw1_continue--;
		}

		if(gTim_10ms_sws_length != 0){		// ʃXCb`pԂPOrPʃ^C}[
			gTim_10ms_sws_length--;
		}

		if(gTim_10ms_sws_continue != 0){	// ʃXCb`pAPOrPʃ^C}[
			gTim_10ms_sws_continue--;
		}

	}
}

// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************

unsigned char	gRTC_sec;						// b vl
unsigned char	gRTC_min;						//  vl
unsigned char	gRTC_hou;						//  vl
unsigned char	gRTC_day;						//  vl
unsigned char	gRTC_mon;						//  vl
unsigned char	gRTC_yer;						// N vl

//								       0  1  2  3  4  5  6  7  8  9  10 11 12 召
const unsigned char gMon_ls[13]     = {30,31,28,31,30,31,30,31,31,30,31,30,31};	// N
const unsigned char gMon_ls_uru[13] = {30,31,29,31,30,31,30,31,31,30,31,30,31};	// 邤N

// 32.768kHz -- 1S Interrupt
#define	COUNT_1S	0
#define	D_TCCR2B	((1 << CS22) | (0 << CS21) | (1 << CS20))	// Timer Start (32.768kHz/128 = 256Hz)
#define	D_TCCR2A	0

//*****************************************
// Timer2 Initial
//  1Sec 荞݂ɐݒ肷 (X'tal=32,768kHz)
//  I[o[t[łPb荞݂ɂ
//  dnm̌@xĂ
//*****************************************
void	Timer2_init(void)
{

	TCCR2B = 0;											// Timer Stop

	PRR &= ~(1 << PRTIM2);								// d͍팸~߂i^C}[Q \j
	TIMSK2 = 0;											// Overflow Interrupt Enable
	ASSR = (1 << AS2);									// 񓯊isnrbPCsnrbQgpj

	TCCR2A = D_TCCR2A;
	TCNT2 = COUNT_1S;									// Timer2 Count Set to ZERO

	gRTC_sec = 50;										// b vl
	gRTC_min = 59;										//  vl
	gRTC_hou = 23;										//  vl
	gRTC_day = 31;										//  vl
	gRTC_mon = 12;										//  vl
	gRTC_yer = 17;										// N vl

	TCCR2B = D_TCCR2B;									// Timer Start

	while(1){
		if((ASSR & ((1 << TCR2AUB)|(1 << TCR2BUB)|(1 << TCN2UB))) == 0){
			break;
		}
	}
	TIFR2 = ((1 << OCF2B) | (1 << OCF2A) | (1 << TOV2));	// ݗvtONA
	TIMSK2 = (1 << TOIE2);								// Overflow Interrupt Enable


}
//***************************
// Timer2 Comper Match A Interrupt
// 	邤NΉiAAPOON̂邤Nɂ͔Ήj

//  1Sec 
//***************************
ISR	(TIMER2_OVF_vect)	
{
	unsigned char d_limit;

	gRTC_sec++;									// b vl
	if(60 <= gRTC_sec){
		gRTC_sec = 0;
		gRTC_min++;								//  vl
		if(60 <= gRTC_min){
			gRTC_min = 0;
			gRTC_hou++;							//  vl
			if(24 <= gRTC_hou){
				gRTC_hou = 0;
				gRTC_day++;						//  vl
				if((gRTC_yer % 4) == 0){		// 邤N
					d_limit = gMon_ls_uru[gRTC_mon];
				}else{
					d_limit = gMon_ls[gRTC_mon];
				}
				if(31 < d_limit){
					d_limit = 31;
				}
				if(d_limit < gRTC_day){
					gRTC_day = 1;
					gRTC_mon++;					//  vl
					if(12 <= gRTC_mon){
						gRTC_mon = 1;
						gRTC_yer++;				// N vl
					}
				}
			}
		}
	}
}
